﻿--
-- SilageBunkerHUD
-- Shows Silage Amount in the Silo Bunkers
--
-- @author  	Syrius
-- @version 	v 0.9
-- @date  		18.12.2014
--

print("SilageBunkerHUD v 0.9 by Syrius");
PosX = 0.826;
PosY = 0.21;
show = false;
SilageBunkerHUD = {};
overlayPath=g_currentModDirectory.."Background.dds";
silo = {};

function SilageBunkerHUD:loadMap(name)
	self.Overlay=createImageOverlay(overlayPath);
	if g_currentMission.onCreateLoadedObjects ~= nil then
		a = 1;
		for k, v in pairs(g_currentMission.onCreateLoadedObjects) do
			if g_currentMission.onCreateLoadedObjects[k].stationName == "BunkerSilo" then
				silo[a] = g_currentMission.onCreateLoadedObjects[g_currentMission.onCreateLoadedObjects[k].id].nodeId;
				a = a + 1;
			end;
		end;
	end;
end;
function SilageBunkerHUD:deleteMap()
end;
function SilageBunkerHUD:mouseEvent(posX, posY, isDown, isUp, button)
end;
function SilageBunkerHUD:keyEvent(unicode, sym, modifier, isDown)
end;
function SilageBunkerHUD:update(dt)
	if InputBinding.hasEvent(InputBinding.TOGGLE_SBunkerHUD) then
		show=not show;
	end;
	if g_currentMission.showHelpText and not show then
		g_currentMission:addHelpButtonText(g_i18n:getText("TOGGLE_SBunkerHUD"), InputBinding.TOGGLE_SBunkerHUD);
	end;

end;
function SilageBunkerHUD:updateTick(dt)
end;
function SilageBunkerHUD:draw()
	
	if PosX < 1 and PosY < 1 and PosX > 0 and PosY > 0 then
		if show == true then
			local Font=0.015;
			local TPosX=PosX + 0.007;
			local TPosYBegin=PosY + 0.09;
			local APosX=PosX+0.14;
			local startPosY = 1;
			setTextBold(false);

			renderOverlay(self.Overlay, PosX, PosY, 0.178, 0.13);
			setTextColor(1, 1, 1, 1);
			renderText(TPosX + 0.005, TPosYBegin + Font, Font, g_i18n:getText("SB_HUD_SILO"));
			renderText(APosX - 0.02, TPosYBegin + Font, Font, g_i18n:getText("SB_HUD_AMOUNT"));
			
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(TPosX + 0.08, TPosYBegin + Font, Font, g_i18n:getText("SB_HUD_CF"));
			
			setTextAlignment(RenderText.ALIGN_LEFT);
			setTextColor(1, 1, 0, 1);
			renderText(TPosX, TPosYBegin-Font, Font, g_i18n:getText("SB_HUD_SILO1")..":");
			renderText(TPosX, TPosYBegin-Font* 2, Font, g_i18n:getText("SB_HUD_SILO2")..":");
			renderText(TPosX, TPosYBegin-Font* 3, Font, g_i18n:getText("SB_HUD_SILO3")..":");
			renderText(TPosX, TPosYBegin-Font* 4, Font, g_i18n:getText("SB_HUD_SILO4")..":");
			renderText(TPosX, TPosYBegin-Font* 5, Font, g_i18n:getText("SB_HUD_SILO5")..":");
		
			setTextAlignment(RenderText.ALIGN_RIGHT);
			for key, value in pairs(silo) do
				obj = g_currentMission:getNodeObject(value);
				if obj.state == 0 and obj.fillLevel > 0 then
					setTextColor(0, 1, 0, 1);
				elseif obj.state == 2 then
					setTextColor(0.3, 0.1, 0, 1);
				elseif obj.state == 0 and obj.fillLevel == 0 then
					setTextColor(1, 1, 1, 1);
				else
					setTextColor(0, 1, 1, 1);
				end;
				compact = round( tostring(obj.compactedFillLevel) / tostring(obj.fillLevel) * 100);
				ferment = round(obj.fermentingTime / obj.fermentingDuration * 100);
				if obj.state == 1 then
					renderText(TPosX + 0.08, TPosYBegin-Font*startPosY, Font, ferment .. "%"); -- fermentation
				end;
				if obj.state == 0 then
					renderText(TPosX + 0.08, TPosYBegin-Font*startPosY, Font, compact .. "%"); -- compacting
				end;
				renderText(APosX, TPosYBegin-Font*startPosY, Font, comma_value(round(obj.fillLevel)) .. " " .. g_i18n:getText("fluid_unit_short"));
				renderText(APosX + 0.03, TPosYBegin-Font*startPosY, Font, "(" .. round(obj.fillLevel / obj.capacity * 100) .. "%)");
				startPosY = startPosY + 1;
			end;
		end;
	end;
end;

addModEventListener(SilageBunkerHUD);


function round(num, idp)
	if Utils.getNoNil(num, 0) > 0 then
		local mult = 10^(idp or 0);
		-- res = math.floor(num * mult + 0.5) / mult;
		res = math.floor(num * mult) / mult;
	else 
		return 0;
	end;
	if res < 1 then res = 1 end;
	return res;
end;

function comma_value(n) -- credit http://richard.warburton.it
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
end